;; marirc 3.0 general aliases
;; By: matt@liek.net
;; irc: irc.semicolon-zero.com #liek

; Hash Tables
;; /hdo - Add/Write to Hash Table | $1 -Table $2 -key $3- -value
alias hdo {
  if (($1 == $null) || ($2 == $null)) {
    errmsg /hdo - Invalid parameters
    goto end 
  }
  hadd $1 $2 $3-
  hsave -o $1 %data.dir $+ $1 $+ .hash 
  :end
}

;; /hsv - Saves hash table | $1 -Table
alias hsv {
  hsave -o $1 %data.dir $+ $1 $+ .hash
}

;; /hdl - Remove from hash table | $1 - Table $2 - key
alias hdl {
  if (($1 == $null) || ($2 == $null)) {
    errmsg /hdl - Invalid parameters ( $+ $1- $+ )
    goto end
  }
  hdel $1 $2
  hsave -o $1 %data.dir $+ $1 $+ .hash 
  :end
}

;; /hld Load hash table | $1 - table
alias hld { 
  hmake $1 100
  if ($isfile(%data.dir $+ $1 $+ .hash) == $false) {
    write -c %data.dir $+ $1 $+ .hash
  }  
  hload $1 %data.dir $+ $1 $+ .hash 
}

;; /hren Renames hash table key | $1 - table $2 - key $3 - newkey
alias hren {
  if (($1 == $null) || ($2 == $null) || ($3 == $null)) {
    errmsg /ren - Invalid parameters ( $+ $1- $+ )
    goto end
  }
  var %h.i = $hget($1,$2)
  if (%h.i == $null) {
    errmsg /hren - Bad Key (Table: $1, Key: $2)
    goto end
  }
  hdl $1 $2
  hdo $1 $3 %h.i
  :end
}

; Other stuff
;; Random Nick Grabber
alias randnick { return $nick($$1,$rand(1,$nick($$1,0))) }

;; /errmsg - report errors | $1- -error text 
alias errmsg {
  echo -a $logo Error: $1-
}