;;; mircamp script

;; Menus 
menu channel,chat,status,query,menubar {
  Winamp
  .Play: wa_play
  .Stop: wa_stop
  .Pause: wa_pause
  .Next Track: wa_next
  .Prev Track: wa_prev
  .Jump Track: jump
  .Toggle Repeat: wa_repeat
  .Toggle Shuffle: wa_shuffle
  .$iif(%wa.trigger == $true,Turn Off Trigger,Turn On Trigger): toggletrigger 
  .Advertise: mp3
  .-  
  .Status = $wa_getstatus: wa_null
  .$iif(($wa_getstatus != Winamp Window was not found!),$wa_title,No Song): wa_null
}

;; Function key bindings
alias F2 { mp3 }
alias F3 { wa_prev }
alias F4 { wa_next }
alias F5 { wa_stop }
alias F6 { wa_pause }
alias F7 { wa_play }
alias F8 { jump }
alias F9 { wa_rew }
alias F10 { wa_fwd }
alias F11 { wa_voldown }
alias F12 { wa_volup }

;; Jump Track
alias jump {
  wa_jumpto $?="Jump to Track:" 
}

;; Mp3 ad
alias mp3self {
  echo -a $wa_winamp
}

alias mp3 {
  say $wa_winamp
}

alias wa_winamp {
  if ($wa_getstatus == Winamp Window was not found!) { echo -a Winamp: ERROR WINAMP NOT FOUND | halt }  
  return $wa_title $chr(91) $+ $wa_tracktime $+ / $+ $wa_tracklength :: $wa_tracknow $+ / $+ $wa_tracktotal :: $wa_bitrate kbps $+ $chr(93) $wa_trigger
}

;; Trigger control
alias toggletrigger {
  if (%wa.trigger == $true) { set %wa.trigger $false }
  else { set %wa.trigger $true }
}

alias trigger {
  if ($$1 == on) {
    set %wa.trigger $true
    echo -a Winamp: Trigger enabled
  }
  elseif ($$1 == off) {
    set %wa.trigger $false
    echo -a Winamp: Trigger disabled
  }
  else {
    echo -a Winamp: Trigger is $iif(%wa.trigger == $true,on,off)
  }
}

alias wa_trigger {
  if (%wa.trigger == $true) {
    return ! $+ $me
  }
  else {
    return
  }
}

;; Catch Trigger
on 1:TEXT:*:#: {
  if (%wa.trigger == $true) {
    if (! $+ $me == $1-) { 
      if ($wa_getstatus != Winamp Window was not found!) {
        dcc send $nick $wa_location
      }
    }
  }
}

;; Debug Print
alias winamp_debug {
  if ($wa_getstatus == Winamp Window was not found!) { echo -a Winamp: ERROR WINAMP NOT FOUND | halt }
  echo -a Status: $wa_getstatus
  echo -a Title: $wa_title
  echo -a Bitrate: $wa_bitrate
  echo -a Freq: $wa_freq
  echo -a Track Time: $wa_tracktime
  echo -a Total Time: $wa_tracklength
  echo -a Location: $wa_location
  echo -a Track Num: $wa_tracknow
  echo -a Track Total: $wa_tracktotal
}

;; Accessors

alias wa_null { halt }

alias wa_prev {
  .dll mircamp.dll WAprev
}

alias wa_play {
  .dll mircamp.dll WAplay
}

alias wa_pause {
  .dll mircamp.dll WApause
}

alias wa_stop {
  .dll mircamp.dll WAstop
}

alias wa_next {
  .dll mircamp.dll WAnext
}

alias wa_rew {
  .dll mircamp.dll WArew
}

alias wa_fwd {
  .dll mircamp.dll WAfwd
}

alias wa_bitrate {
  return $dll(mircamp.dll,WAbitrate,"")
}

alias wa_freq {
  return $dll(mircamp.dll,WAfreq,"")
}

alias wa_jumpto {
  .dll mircamp.dll WAjumpto $$1
}

alias wa_repeat {
  .dll mircamp.dll WArepeat
}

alias wa_shuffle {
  .dll mircamp.dll WAshuffle
}

alias wa_tracktime {
  return $dll(mircamp.dll,WAtracktime,"")
}

alias wa_tracklength {
  return $dll(mircamp.dll,WAtracklength,"")
}

alias wa_location {
  return $dll(mircamp.dll,WAlocation,"")
}

alias wa_title {
  return $dll(mircamp.dll,WAtitle,"")
}

alias wa_tracknow {
  return $dll(mircamp.dll,WAtracknow,"")
}

alias wa_tracktotal {
  return $dll(mircamp.dll,WAtracktotal,"")
}

alias wa_volup {
  .dll mircamp.dll WAvolup
}

alias wa_voldown {
  .dll mircamp.dll WAvoldown
}

alias wa_getstatus {
  return $dll(mircamp.dll,WAgetstatus,"")
}

on 1:LOAD: {
  echo -a mIRCamp loaded!!!
  set %wa.trigger $true
}
