; marirc 3.0 Themes
; By: matt@liek.net
; IRC - irc.semicolon-zero.com #liek

alias maketheme {
  var %themename = $?="Name of theme?"
  var %themeshortname = $?="Short name of theme:"
  var %themecreator = $?"Creator of theme?"
  var %themeversion = $?"Version of theme?"

  var %filename = %theme.dir $+ %themeshortname $+ .ini

  ;; Write info
  writeini %filename info name %themename
  writeini %filename info creator %themecreator
  writeini %filename info version %themeversion
  
  ;; Save color settings
  var %i = 1
  while (%i <= $hget(colors,0).item) {
    writeini %filename colors $hget(colors,%i).item $hget(colors,%i).data
    inc %i 1
  }

  ;; Save background
  writeini %filename other main $color(background)
  writeini %filename other nicklist $color(listbox)
  writeini %filename other edit $color(editbox)
  writeini %filename other inactive $color(inactive)
  
  ;; Save text stuff
  writeini %filename text event $hget(preload,event)
  writeini %filename text tstamp $hget(preload,tstamp)
  writeini %filename text highlight $hget(preload,highlight)
  writeini %filename text logo $hget(preload,logo)
  writeini %filename text ident $hget(preload,ident)

  smsg Theme created!
}

alias loadtheme {
  var %filename = %theme.dir $+ $1

  if ($isfile(%filename) == $true) {
    smsg Loading %filename

    var %i = 1
    var %i.end $ini(%filename,colors,0)
    while (%i <= %i.end) {
      hdo colors $ini(%filename,colors,%i) $readini(%filename,colors,$ini(%filename,colors,%i))
      inc %i 1
    }

    ;; Load backgrounds
    color background $readini(%filename,other,main)
    color listbox $readini(%filename,other,nicklist)
    color editbox $readini(%filename,other,edit)
    color inactive $readini(%filename,other,inactive)
    color own $readini(%filename,colors,text)
    color normal $readini(%filename,colors,text)
    color editbox text $readini(%filename,colors,opnick)

    ;; Load other settings
    hdo preload event $readini(%filename,text,event)
    hdo preload tstamp $readini(%filename,text,tstamp)
    hdo preload highlight $readini(%filename,text,highlight)
    hdo preload logo $readini(%filename,text,logo)
    hdo preload ident $readini(%filename,text,ident)
   
    ;; loop through channels, set nicklist colors
    scid -at1 updatenicklists

    ;; Inform user
    smsg Loaded theme $readini(%filename,info,name) $readini(%filename,info,version) By $readini(%filename,info,creator)
  }
  else {
    smsg No theme
  }
}

alias updatenicklists {
  var %i = 1
  var %i.end = $chan(0)
  while (%i <= %i.end) {
    var %j = 1
    var %j.end = $nick($chan(%i),0)
    while (%j <= %j.end) {
      if ($nick($chan(%i),%j) isop $chan(%i)) {
        cline -m $hget(colors,opnick) $chan(%i) $fline($chan(%i),$nick($chan(%i),%j),1,1)
      }
      elseif ($nick($chan(%i),%j) ishelp $chan(%i)) {
        cline -m $hget(colors,hnick) $chan(%i) $fline($chan(%i),$nick($chan(%i),%j),1,1)
      }
      elseif ($nick($chan(%i),%j) isvo $chan(%i)) {
        cline -m $hget(colors,vnick) $chan(%i) $fline($chan(%i),$nick($chan(%i),%j),1,1)
      }
      else {
        cline -m $hget(colors,regnick) $chan(%i) $fline($chan(%i),$nick($chan(%i),%j),1,1)
      }
      inc %j 1
    }
    inc %i 1
  }
}
